//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int            DeMarkerPeriod  = 14.0;
extern ENUM_MA_METHOD DeMarkerMa_Mode = MODE_LWMA;

double buffer2[];
double buffer3[];
double DeMarkerBuffer[];
double demH[];
double demL[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,buffer2); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer3); SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(3,DeMarkerBuffer);
   SetIndexBuffer(4,demH);
   SetIndexBuffer(5,demL);
   SetIndexBuffer(6,trend);
   IndicatorShortName("DeMarker ("+DeMarkerPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      demH[i] = 0; if(High[i] > High[i+1]) demH[i] = High[i]  - High[i+1];
      demL[i] = 0; if(Low[i] < Low[i+1])   demL[i] = Low[i+1] - Low[i];
      double smtH = MathMax(iMAOnArray(demH,0,DeMarkerPeriod,0,DeMarkerMa_Mode,i),0);
      double smtL = MathMax(iMAOnArray(demL,0,DeMarkerPeriod,0,DeMarkerMa_Mode,i),0);
        if (smtH+smtL!=0)
              DeMarkerBuffer[i] = smtH/(smtH+smtL);
        else  DeMarkerBuffer[i] = 0;
        
        //
        //
        //
        //
        //
        
        buffer2[i] = EMPTY_VALUE;
        buffer3[i] = EMPTY_VALUE;
        trend[i] = trend[i+1];
        if (DeMarkerBuffer[i]>DeMarkerBuffer[i+1]) trend[i] = 1;
        if (DeMarkerBuffer[i]<DeMarkerBuffer[i+1]) trend[i] =-1;
        if (trend[i] == 1) buffer2[i] = 1;
        if (trend[i] ==-1) buffer3[i] = 1;
         
   }   
   return(0);
}


